#############################################################
###     This version is executed on NASA-GSFC-seliana     ###
#############################################################
import numpy as np
import time
import os
import itertools
from multiprocessing import Pool, cpu_count

sams_location = "/Home/eud/layung/SAM_code/ceers.20210223"         #### Update This: path to gf
lib_path      = "/Home/eud/layung/SAM_code/gflib/"                 #### Update This: path to gflib


# set up where the output is and create a folder under it indentified by a time stamp
run_path  = "%s/run_%s"%(os.getcwd(),time.strftime('%Y%m%d'))
os.system("mkdir %s"%run_path)


def run_gf(INPUT):
    field, realization = INPUT[0], INPUT[1]

    rid = '%s.%s'%(field, realization)
    os.system('mkdir %s/%s'%(run_path,rid))

    rid_path  = '%s/%s/'%(run_path,rid)
    para_name = 'param.%s'%rid

    # Now create the parameter file using paragen.py. Please pay close attention to the parameters that goes into make the parameter file.
    os.system('python paragen.py %s %s %s %s %s'%(para_name, rid_path, lib_path, field, realization))

    # Now run sams in the created directory, using the parameter file we just created.
    os.system('cd %s && ./gf %s/%s &> %s/%s'%(sams_location,rid_path,para_name,rid_path,"output.txt"))




#Variables that get looped over and over
fields        = [ "cosmos", "egs", "goodsn", "goodss", "uds" ]
realizations  = [ 0, 1, 2, 3, 4, 5, 6, 7 ]



#Create the input file that goes into the module to run the code
INPUT      = np.array(list(itertools.product(fields,realizations)))

#The number of nodes to use and start the multi-processing
PoolNumber = cpu_count() - 4
pool       = Pool(processes = PoolNumber)

#This is where the code is called
out        = np.array(pool.map(run_gf,INPUT))

#Close up the multi-processing
pool.close()
